Whamcloud - gitweb
LU-13019 tests: replace usleep in test scripts
[fs/lustre-release.git] / lustre / tests / replay-single.sh
index 60b3ef1..726d773 100755 (executable)
@@ -1,40 +1,33 @@
 #!/bin/bash
 
 set -e
-#set -v
-
-#
-# This test needs to be run on the client
-#
-SAVE_PWD=$PWD
-export MULTIOP=${MULTIOP:-multiop}
-LUSTRE=${LUSTRE:-$(cd $(dirname $0)/..; echo $PWD)}
-SETUP=${SETUP:-}
-CLEANUP=${CLEANUP:-}
+
+LUSTRE=${LUSTRE:-$(dirname $0)/..}
 . $LUSTRE/tests/test-framework.sh
 init_test_env $@
-. ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
 init_logging
-CHECK_GRANT=${CHECK_GRANT:-"yes"}
-GRANT_CHECK_LIST=${GRANT_CHECK_LIST:-""}
-
-require_dsh_mds || exit 0
-
-# Skip these tests
-# bug number for skipped tests:
-#                                    LU-472
-ALWAYS_EXCEPT="$REPLAY_SINGLE_EXCEPT 61d"
-# UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
-#                                  7.5  (min)"
-[ "$SLOW" = "no" ] && EXCEPT_SLOW="44b"
+ALWAYS_EXCEPT="$REPLAY_SINGLE_EXCEPT "
 
-[ $(facet_fstype $SINGLEMDS) = "zfs" ] &&
-# bug number for skipped test:        LU-1867  LU-3127
-       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 89        73b"
+if [ "$mds1_FSTYPE" = zfs ]; then
+       # bug number for skipped test: LU-11388
+       ALWAYS_EXCEPT+="               131b"
+       # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
+fi
+if $SHARED_KEY; then
+       # bug number for skipped tests: LU-9795 (all below)
+       ALWAYS_EXCEPT="$ALWAYS_EXCEPT   0b      0c      0d      34      45"
+       ALWAYS_EXCEPT="$ALWAYS_EXCEPT   47      58b     58c     71a     85a"
+       ALWAYS_EXCEPT="$ALWAYS_EXCEPT   85b     86      88      89      90"
+       ALWAYS_EXCEPT="$ALWAYS_EXCEPT   93a     100a    100b    120"
+fi
 
 build_test_filter
 
+CHECK_GRANT=${CHECK_GRANT:-"yes"}
+GRANT_CHECK_LIST=${GRANT_CHECK_LIST:-""}
+
+require_dsh_mds || exit 0
 check_and_setup_lustre
 
 mkdir -p $DIR
@@ -120,6 +113,27 @@ test_2b() {
 }
 run_test 2b "touch"
 
+test_2c() {
+       replay_barrier $SINGLEMDS
+       $LFS setstripe -c $OSTCOUNT $DIR/$tfile
+       fail $SINGLEMDS
+       $CHECKSTAT -t file $DIR/$tfile ||
+               error "$CHECKSTAT $DIR/$tfile check failed"
+}
+run_test 2c "setstripe replay"
+
+test_2d() {
+       [[ "$mds1_FSTYPE" = zfs ]] &&
+               [[ "$MDS1_VERSION" -lt $(version_code 2.12.51) ]] &&
+               skip "requires LU-10143 fix on MDS"
+       replay_barrier $SINGLEMDS
+       $LFS setdirstripe -i 0 -c $MDSCOUNT $DIR/$tdir
+       fail $SINGLEMDS
+       $CHECKSTAT -t dir $DIR/$tdir ||
+               error "$CHECKSTAT $DIR/$tdir check failed"
+}
+run_test 2d "setdirstripe replay"
+
 test_3a() {
        local file=$DIR/$tfile
        replay_barrier $SINGLEMDS
@@ -449,35 +463,47 @@ run_test 20a "|X| open(O_CREAT), unlink, replay, close (test mds_cleanup_orphans
 
 test_20b() { # bug 10480
        local wait_timeout=$((TIMEOUT * 4))
-       local BEFOREUSED
-       local AFTERUSED
+       local extra=$(fs_log_size)
+       local n_attempts=1
+
+       sync_all_data
+       $LFS setstripe -i 0 -c 1 $DIR
+
+       local beforeused=$(df -P $DIR | tail -1 | awk '{ print $3 }')
 
-       BEFOREUSED=$(df -P $DIR | tail -1 | awk '{ print $3 }')
        dd if=/dev/zero of=$DIR/$tfile bs=4k count=10000 &
        while [ ! -e $DIR/$tfile ] ; do
-               usleep 60                      # give dd a chance to start
+               sleep 0.01                      # give dd a chance to start
        done
 
-       $GETSTRIPE $DIR/$tfile || error "$GETSTRIPE $DIR/$tfile failed"
+       $LFS getstripe $DIR/$tfile || error "$LFS getstripe $DIR/$tfile failed"
        # make it an orphan
        rm -f $DIR/$tfile || error "rm -f $DIR/$tfile failed"
        mds_evict_client
-       client_up || client_up || true    # reconnect
+       client_up || client_up || true          # reconnect
 
-       do_facet $SINGLEMDS "lctl set_param -n osd*.*MDT*.force_sync 1"
+       do_facet $SINGLEMDS "lctl set_param -n osd*.*MDT*.force_sync=1"
 
-       fail $SINGLEMDS                            # start orphan recovery
+       fail $SINGLEMDS                         # start orphan recovery
        wait_recovery_complete $SINGLEMDS || error "MDS recovery not done"
-       wait_delete_completed_mds $wait_timeout ||
-               error "delete did not complete"
+       wait_delete_completed $wait_timeout || error "delete did not finish"
+       sync_all_data
 
-       AFTERUSED=$(df -P $DIR | tail -1 | awk '{ print $3 }')
-       log "before $BEFOREUSED, after $AFTERUSED"
-       (( $AFTERUSED > $BEFOREUSED + $(fs_log_size) )) &&
-               error "after $AFTERUSED > before $BEFOREUSED"
-       return 0
+       while true; do
+               local afterused=$(df -P $DIR | tail -1 | awk '{ print $3 }')
+               log "before $beforeused, after $afterused"
+
+               (( $beforeused + $extra >= $afterused )) && break
+               n_attempts=$((n_attempts + 1))
+               [ $n_attempts -gt 3 ] &&
+                       error "after $afterused > before $beforeused + $extra"
+
+               wait_zfs_commit $SINGLEMDS 5
+               sync_all_data
+       done
 }
-run_test 20b "write, unlink, eviction, replay, (test mds_cleanup_orphans)"
+
+run_test 20b "write, unlink, eviction, replay (test mds_cleanup_orphans)"
 
 test_20c() { # bug 10480
        multiop_bg_pause $DIR/$tfile Ow_c ||
@@ -799,7 +825,7 @@ test_36() {
        checkstat $DIR/$tfile
        facet_failover $SINGLEMDS
        cancel_lru_locks mdc
-       if dmesg | grep "unknown lock cookie"; then
+       if $LCTL dk | grep "stale lock .*cookie"; then
                error "cancel after replay failed"
        fi
 }
@@ -819,7 +845,7 @@ test_37() {
        do_facet $SINGLEMDS dmesg -c >/dev/null
        fail_abort $SINGLEMDS
        kill -USR1 $pid || error "multiop $pid not running"
-       do_facet $SINGLEMDS dmesg | grep "error .* unlinking .* from PENDING" &&
+       do_facet $SINGLEMDS dmesg | grep "error unlinking orphan" &&
                error "error unlinking files"
        wait $pid || error "multiop $pid failed"
        sync
@@ -910,13 +936,11 @@ run_test 40 "cause recovery in ptlrpc, ensure IO continues"
 # the page, guarnateeing that the unlock from the RPC completion would
 # assert on trying to unlock the unlocked page.
 test_41() {
-    [ $OSTCOUNT -lt 2 ] &&
-        skip_env "skipping test 41: we don't have a second OST to test with" &&
-        return
+       [ $OSTCOUNT -lt 2 ] && skip_env "needs >= 2 OSTs" && return
 
        local f=$MOUNT/$tfile
        # make sure the start of the file is ost1
-       $SETSTRIPE -S $((128 * 1024)) -i 0 $f
+       $LFS setstripe -S $((128 * 1024)) -i 0 $f
        do_facet client dd if=/dev/zero of=$f bs=4k count=1 ||
                error "dd on client failed"
        cancel_lru_locks osc
@@ -1000,7 +1024,7 @@ test_44a() { # was test_44
                do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000701"
                # lctl below may fail, it is valid case
                $LCTL --device $mdcdev recover
-               df $MOUNT
+               $LFS df $MOUNT
        done
        do_facet $SINGLEMDS "lctl set_param fail_loc=0"
        [ $at_max_saved -ne 0 ] && at_max_set $at_max_saved mds
@@ -1079,12 +1103,12 @@ test_45() {
 run_test 45 "Handle failed close"
 
 test_46() {
-       dmesg -c >/dev/null
        drop_reply "touch $DIR/$tfile"
        fail $SINGLEMDS
        # ironically, the previous test, 45, will cause a real forced close,
        # so just look for one for this test
-       dmesg | grep -i "force closing client file handle for $tfile" &&
+       local FID=$($LFS path2fid $tfile)
+       $LCTL dk | grep -i "force closing file handle $FID" &&
                error "found force closing in dmesg"
        return 0
 }
@@ -1118,8 +1142,7 @@ run_test 47 "MDS->OSC failure during precreate cleanup (2824)"
 
 test_48() {
        remote_ost_nodsh && skip "remote OST with nodsh" && return 0
-       [ "$OSTCOUNT" -lt "2" ] &&
-               skip_env "$OSTCOUNT < 2 OSTs -- skipping" && return
+       [ "$OSTCOUNT" -lt "2" ] && skip_env "needs >= 2 OSTs" && return
 
        replay_barrier $SINGLEMDS
        createmany -o $DIR/$tfile 20  ||
@@ -1129,6 +1152,10 @@ test_48() {
        do_facet ost1 "lctl set_param fail_loc=0x80000216"
        client_up || error "client_up failed"
 
+       # let the MDS discover the OST failure, attempt to recover, fail
+       # and recover again.
+       sleep $((3 * TIMEOUT))
+
        createmany -o $DIR/$tfile 20 20 ||
                error "createmany recraete $DIR/$tfile failed"
        unlinkmany $DIR/$tfile 40 || error "unlinkmany $DIR/$tfile failed"
@@ -1152,9 +1179,8 @@ run_test 50 "Double OSC recovery, don't LASSERT (3812)"
 
 # b3764 timed out lock replay
 test_52() {
-       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.90) ] &&
-               skip "MDS prior to 2.6.90 handle LDLM_REPLY_NET incorrectly" &&
-               return 0
+       [ "$MDS1_VERSION" -lt $(version_code 2.6.90) ] &&
+               skip "MDS prior to 2.6.90 handle LDLM_REPLY_NET incorrectly"
 
        touch $DIR/$tfile || error "touch $DIR/$tfile failed"
        cancel_lru_locks mdc
@@ -1795,7 +1821,7 @@ test_65a() #bug 3055
     createmany -o $DIR/$tfile 10 > /dev/null
     unlinkmany $DIR/$tfile 10 > /dev/null
     # check for log message
-    $LCTL dk | grep "Early reply #" || error "No early reply"
+    $LCTL dk | grep -i "Early reply #" || error "No early reply"
     debugrestore
     # client should show REQ_DELAY estimates
     lctl get_param -n mdc.${FSNAME}-MDT0000-mdc-*.timeouts | grep portal
@@ -1815,8 +1841,8 @@ test_65b() #bug 3055
        $LCTL dk > /dev/null
        # Slow down a request to the current service time, this is critical
        # because previous tests may have caused this value to increase.
-       $SETSTRIPE --stripe-index=0 --stripe-count=1 $DIR/$tfile ||
-               error "$SETSTRIPE failed for $DIR/$tfile"
+       $LFS setstripe --stripe-index=0 --stripe-count=1 $DIR/$tfile ||
+               error "$LFS setstripe failed for $DIR/$tfile"
 
        multiop $DIR/$tfile Ow1yc
        REQ_DELAY=`lctl get_param -n osc.${FSNAME}-OST0000-osc-*.timeouts |
@@ -1828,14 +1854,14 @@ test_65b() #bug 3055
        do_facet ost1 $LCTL set_param fail_loc=0x224
 
        rm -f $DIR/$tfile
-       $SETSTRIPE --stripe-index=0 --stripe-count=1 $DIR/$tfile ||
-               error "$SETSTRIPE failed"
+       $LFS setstripe --stripe-index=0 --stripe-count=1 $DIR/$tfile ||
+               error "$LFS setstripe failed"
        # force some real bulk transfer
        multiop $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
 
        do_facet ost1 $LCTL set_param fail_loc=0
        # check for log message
-       $LCTL dk | grep "Early reply #" || error "No early reply"
+       $LCTL dk | grep -i "Early reply #" || error "No early reply"
        debugrestore
        # client should show REQ_DELAY estimates
        lctl get_param -n osc.${FSNAME}-OST0000-osc-*.timeouts | grep portal
@@ -1882,7 +1908,7 @@ test_66b() #bug 3055
        $LCTL set_param fail_val=$(($ORIG + 5))
        #define OBD_FAIL_PTLRPC_PAUSE_REP      0x50c
        $LCTL set_param fail_loc=0x50c
-       ls $DIR/$tfile > /dev/null 2>&1
+       touch $DIR/$tfile > /dev/null 2>&1
        $LCTL set_param fail_loc=0
        CUR=$(lctl get_param -n mdc.${FSNAME}-MDT0000*.timeouts |
                awk '/network/ {print $4}')
@@ -1923,16 +1949,17 @@ test_67b() #bug 3055
     at_start || return 0
     CONN1=$(lctl get_param -n osc.*.stats | awk '/_connect/ {total+=$2} END {print total}')
 
-    # exhaust precreations on ost1
-    local OST=$(ostname_from_index 0)
-    local mdtosc=$(get_mdtosc_proc_path mds $OST)
-    local last_id=$(do_facet $SINGLEMDS lctl get_param -n \
-        osc.$mdtosc.prealloc_last_id)
-    local next_id=$(do_facet $SINGLEMDS lctl get_param -n \
-        osc.$mdtosc.prealloc_next_id)
+       # exhaust precreations on ost1
+       local OST=$(ostname_from_index 0)
+       local mdtosc=$(get_mdtosc_proc_path mds $OST)
+       local last_id=$(do_facet $SINGLEMDS lctl get_param -n \
+                       osp.$mdtosc.prealloc_last_id)
+       local next_id=$(do_facet $SINGLEMDS lctl get_param -n \
+                       osp.$mdtosc.prealloc_next_id)
 
        mkdir -p $DIR/$tdir/${OST} || error "mkdir $DIR/$tdir/${OST} failed"
-       $SETSTRIPE -i 0 -c 1 $DIR/$tdir/${OST} || error "$SETSTRIPE failed"
+       $LFS setstripe -i 0 -c 1 $DIR/$tdir/${OST} ||
+               error "$LFS setstripe failed"
        echo "Creating to objid $last_id on ost $OST..."
 #define OBD_FAIL_OST_PAUSE_CREATE        0x223
     do_facet ost1 "$LCTL set_param fail_val=20000"
@@ -1974,8 +2001,8 @@ test_68 () #bug 13813
        do_facet ost1 "echo $TIMEOUT >> $ldlm_enqueue_min_r"
 
        mkdir $DIR/$tdir || error "mkdir $DIR/$tdir failed"
-       $SETSTRIPE --stripe-index=0 -c 1 $DIR/$tdir ||
-               error "$SETSTRIPE failed for $DIR/$tdir"
+       $LFS setstripe --stripe-index=0 -c 1 $DIR/$tdir ||
+               error "$LFS setstripe failed for $DIR/$tdir"
        #define OBD_FAIL_LDLM_PAUSE_CANCEL       0x312
        $LCTL set_param fail_val=$(($TIMEOUT - 1))
        $LCTL set_param fail_loc=0x80000312
@@ -2213,6 +2240,7 @@ test_70d () {
                        }
                        rm -rf $DIR/$tdir/test || {
                                echo "rmdir fails"
+                               ls -lR $DIR/$tdir
                                break
                        }
 
@@ -2227,6 +2255,7 @@ test_70d () {
 
                        rm -rf $DIR/$tdir/test1 || {
                                echo "rmdir fails"
+                               ls -lR $DIR/$tdir/test1
                                break
                        }
                done
@@ -2242,17 +2271,12 @@ test_70d () {
 }
 run_test 70d "mkdir/rmdir striped dir ${MDSCOUNT}mdts recovery"
 
-cleanup_70e() {
-       trap 0
-       kill -9 $rename_70e_pid
-}
-
 test_70e () {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
        local clients=${CLIENTS:-$HOSTNAME}
        local rc=0
 
-       echo ha > /proc/sys/lnet/debug
+       lctl set_param debug=+ha
        zconf_mount_clients $clients $MOUNT
 
        local duration=300
@@ -2265,45 +2289,40 @@ test_70e () {
        $LFS mkdir -i0 $DIR/$tdir/test_1
        touch $DIR/$tdir/test_0/a
        touch $DIR/$tdir/test_1/b
-       trap cleanup_70e EXIT
        (
-               while true; do
-                       mrename $DIR/$tdir/test_0/a $DIR/$tdir/test_1/b > \
-                                               /dev/null || {
-                               echo "a->b fails"
-                               break;
-                       }
+       while true; do
+               mrename $DIR/$tdir/test_0/a $DIR/$tdir/test_1/b > /dev/null || {
+                       echo "a->b fails"
+                       break;
+               }
 
-                       checkstat $DIR/$tdir/test_0/a && {
-                               echo "a still exists"
-                               break
-                       }
+               checkstat $DIR/$tdir/test_0/a && {
+                       echo "a still exists"
+                       break
+               }
 
-                       checkstat $DIR/$tdir/test_1/b || {
-                               echo "b still  exists"
-                               break
-                       }
+               checkstat $DIR/$tdir/test_1/b || {
+                       echo "b still  exists"
+                       break
+               }
 
-                       touch $DIR/$tdir/test_0/a || {
-                               echo "touch a fails"
-                               break
-                       }
+               touch $DIR/$tdir/test_0/a || {
+                       echo "touch a fails"
+                       break
+               }
 
-                       mrename $DIR/$tdir/test_1/b $DIR/$tdir/test_0/a > \
-                                               /dev/null || {
-                               echo "a->a fails"
-                               break;
-                       }
-               done
+               mrename $DIR/$tdir/test_1/b $DIR/$tdir/test_0/a > /dev/null || {
+                       echo "a->a fails"
+                       break;
+               }
+       done
        )&
        rename_70e_pid=$!
-       echo "Started  $rename_70e_pid"
+       stack_trap "kill -9 $rename_70e_pid" EXIT
+       echo "Started PID=$rename_70e_pid"
 
        random_fail_mdt 2 $duration $rename_70e_pid
        kill -0 $rename_70e_pid || error "rename $rename_70e_pid stopped"
-
-       cleanup_70e
-       true
 }
 run_test 70e "rename cross-MDT with random fails"
 
@@ -2348,7 +2367,8 @@ test_70f_loop(){
        DD_OPTS=
 
        mkdir -p $DIR/$tdir || error "cannot create $DIR/$tdir directory"
-       $SETSTRIPE -c -1 $DIR/$tdir || error "cannot $SETSTRIPE $DIR/$tdir"
+       $LFS setstripe -c -1 $DIR/$tdir ||
+               error "cannot $LFS setstripe $DIR/$tdir"
 
        touch $stopflag
        while [ -f $stopflag ]; do
@@ -2373,8 +2393,8 @@ test_70f() {
 #      [ $CLIENTCOUNT -lt 2 ] &&
 #              { skip "Need 2 or more clients, have $CLIENTCOUNT" && return; }
 
-       [[ $(lustre_version_code ost1) -lt $(version_code 2.9.53) ]] &&
-               skip "Need server version at least 2.9.53" && return
+       [[ "$OST1_VERSION" -lt $(version_code 2.9.53) ]] &&
+               skip "Need server version at least 2.9.53"
 
        echo "mount clients $CLIENTS ..."
        zconf_mount_clients $CLIENTS $MOUNT
@@ -2518,8 +2538,8 @@ test_73b() {
        rm -f $DIR/$tfile
 
        replay_barrier $SINGLEMDS
-       #define OBD_FAIL_LDLM_REPLY       0x30c
-       do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000030c"
+       #define OBD_FAIL_MDS_LDLM_REPLY_NET       0x157
+       do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000157"
        fail $SINGLEMDS
        kill -USR1 $pid
        wait $pid || error "multiop pid failed"
@@ -2545,18 +2565,18 @@ test_74() {
 run_test 74 "Ensure applications don't fail waiting for OST recovery"
 
 remote_dir_check_80() {
-       local MDTIDX=1
+       local mdtidx=1
        local diridx
        local fileidx
 
-       diridx=$($GETSTRIPE -M $remote_dir) ||
-               error "$GETSTRIPE -M $remote_dir failed"
-       [ $diridx -eq $MDTIDX ] || error "$diridx != $MDTIDX"
+       diridx=$($LFS getstripe -m $remote_dir) ||
+               error "$LFS getstripe -m $remote_dir failed"
+       [ $diridx -eq $mdtidx ] || error "$diridx != $mdtidx"
 
        createmany -o $remote_dir/f-%d 20 || error "creation failed"
-       fileidx=$($GETSTRIPE -M $remote_dir/f-1) ||
-               error "$GETSTRIPE -M $remote_dir/f-1 failed"
-       [ $fileidx -eq $MDTIDX ] || error "$fileidx != $MDTIDX"
+       fileidx=$($LFS getstripe -m $remote_dir/f-1) ||
+               error "$LFS getstripe -m $remote_dir/f-1 failed"
+       [ $fileidx -eq $mdtidx ] || error "$fileidx != $mdtidx"
 
        return 0
 }
@@ -2600,7 +2620,7 @@ test_80b() {
        local remote_dir=$DIR/$tdir/remote_dir
 
        mkdir $DIR/$tdir || error "mkdir $DIR/$tdir failed"
-       #define OBD_FAIL_UPDATE_OBJ_NET_REP     0x1701
+       #define OBD_FAIL_OUT_UPDATE_NET_REP     0x1701
        do_facet mds${MDTIDX} lctl set_param fail_loc=0x1701
        $LFS mkdir -i $MDTIDX $remote_dir &
        local CLIENT_PID=$!
@@ -2619,17 +2639,19 @@ test_80b() {
 run_test 80b "DNE: create remote dir, drop update rep from MDT0, fail MDT1"
 
 test_80c() {
-       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$mds1_FSTYPE" = zfs ]] &&
+               [[ $MDS1_VERSION -lt $(version_code 2.12.51) ]] &&
+               skip "requires LU-10143 fix on MDS"
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs"
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
-               skip "MDTs needs to be on diff hosts for HARD fail mode" &&
-               return 0
+               skip "MDTs needs to be on diff hosts for HARD fail mode"
 
        local MDTIDX=1
        local remote_dir=$DIR/$tdir/remote_dir
 
        mkdir $DIR/$tdir || error "mkdir $DIR/$tdir failed"
-       #define OBD_FAIL_UPDATE_OBJ_NET_REP     0x1701
+       #define OBD_FAIL_OUT_UPDATE_NET_REP     0x1701
        do_facet mds${MDTIDX} lctl set_param fail_loc=0x1701
        $LFS mkdir -i $MDTIDX $remote_dir &
        local CLIENT_PID=$!
@@ -2649,12 +2671,15 @@ test_80c() {
 run_test 80c "DNE: create remote dir, drop update rep from MDT1, fail MDT[0,1]"
 
 test_80d() {
-       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$mds1_FSTYPE" = zfs ]] &&
+               [[ $MDS1_VERSION -lt $(version_code 2.12.51) ]] &&
+               skip "requires LU-10143 fix on MDS"
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs"
        local MDTIDX=1
        local remote_dir=$DIR/$tdir/remote_dir
 
        mkdir $DIR/$tdir || error "mkdir $DIR/$tdir failed"
-       #define OBD_FAIL_UPDATE_OBJ_NET_REP     0x1701
+       #define OBD_FAIL_OUT_UPDATE_NET_REP     0x1701
        do_facet mds${MDTIDX} lctl set_param fail_loc=0x1701
        $LFS mkdir -i $MDTIDX $remote_dir &
        local CLIENT_PID=$!
@@ -2811,7 +2836,7 @@ test_81a() {
        $LFS mkdir -i $MDTIDX $remote_dir || error "lfs mkdir failed"
 
        touch $remote_dir || error "touch $remote_dir failed"
-       # OBD_FAIL_OBJ_UPDATE_NET_REP       0x1701
+       # OBD_FAIL_OUT_UPDATE_NET_REP       0x1701
        do_facet mds${MDTIDX} lctl set_param fail_loc=0x1701
        rmdir $remote_dir &
        local CLIENT_PID=$!
@@ -2821,7 +2846,7 @@ test_81a() {
 
        wait $CLIENT_PID || error "rm remote dir failed"
 
-       stat $remote_dir 2&>/dev/null && error "$remote_dir still exist!"
+       stat $remote_dir &>/dev/null && error "$remote_dir still exist!"
 
        rm -rf $DIR/$tdir || error "rmdir failed"
 
@@ -2841,7 +2866,7 @@ test_81b() {
        mkdir $DIR/$tdir || error "mkdir $DIR/$tdir failed"
        $LFS mkdir -i $MDTIDX $remote_dir || error "lfs mkdir failed"
 
-       # OBD_FAIL_OBJ_UPDATE_NET_REP       0x1701
+       # OBD_FAIL_OUT_UPDATE_NET_REP       0x1701
        do_facet mds${MDTIDX} lctl set_param fail_loc=0x1701
        rmdir $remote_dir &
        local CLIENT_PID=$!
@@ -2851,7 +2876,7 @@ test_81b() {
 
        wait $CLIENT_PID || error "rm remote dir failed"
 
-       stat $remote_dir 2&>/dev/null && error "$remote_dir still exist!"
+       stat $remote_dir &>/dev/null && error "$remote_dir still exist!"
 
        rm -rf $DIR/$tdir || error "rmdir failed"
 
@@ -2872,7 +2897,7 @@ test_81c() {
        mkdir $DIR/$tdir || error "mkdir $DIR/$tdir failed"
        $LFS mkdir -i $MDTIDX $remote_dir || error "lfs mkdir failed"
 
-       # OBD_FAIL_OBJ_UPDATE_NET_REP       0x1701
+       # OBD_FAIL_OUT_UPDATE_NET_REP       0x1701
        do_facet mds${MDTIDX} lctl set_param fail_loc=0x1701
        rmdir $remote_dir &
        local CLIENT_PID=$!
@@ -2884,7 +2909,7 @@ test_81c() {
 
        wait $CLIENT_PID || error "rm remote dir failed"
 
-       stat $remote_dir 2&>/dev/null && error "$remote_dir still exist!"
+       stat $remote_dir &>/dev/null && error "$remote_dir still exist!"
 
        rm -rf $DIR/$tdir || error "rmdir failed"
 
@@ -2900,7 +2925,7 @@ test_81d() {
        mkdir $DIR/$tdir || error "mkdir $DIR/$tdir failed"
        $LFS mkdir -i $MDTIDX $remote_dir || error "lfs mkdir failed"
 
-       # OBD_FAIL_OBJ_UPDATE_NET_REP       0x1701
+       # OBD_FAIL_OUT_UPDATE_NET_REP       0x1701
        do_facet mds${MDTIDX} lctl set_param fail_loc=0x1701
        rmdir $remote_dir &
        local CLIENT_PID=$!
@@ -2911,7 +2936,7 @@ test_81d() {
 
        wait $CLIENT_PID || error "rm remote dir failed"
 
-       stat $remote_dir 2&>/dev/null && error "$remote_dir still exist!"
+       stat $remote_dir &>/dev/null && error "$remote_dir still exist!"
 
        rm -rf $DIR/$tdir || error "rmdir failed"
 
@@ -2943,7 +2968,7 @@ test_81e() {
 
        wait $CLIENT_PID || error "rm remote dir failed"
 
-       stat $remote_dir 2&>/dev/null && error "$remote_dir still exist!"
+       stat $remote_dir &>/dev/null && error "$remote_dir still exist!"
 
        rm -rf $DIR/$tdir || error "rmdir failed"
 
@@ -2974,7 +2999,7 @@ test_81f() {
 
        wait $CLIENT_PID || error "rm remote dir failed"
 
-       stat $remote_dir 2&>/dev/null && error "$remote_dir still exist!"
+       stat $remote_dir &>/dev/null && error "$remote_dir still exist!"
 
        rm -rf $DIR/$tdir || error "rmdir failed"
 
@@ -3007,7 +3032,7 @@ test_81g() {
 
        wait $CLIENT_PID || error "rm remote dir failed"
 
-       stat $remote_dir 2&>/dev/null && error "$remote_dir still exist!"
+       stat $remote_dir &>/dev/null && error "$remote_dir still exist!"
 
        rm -rf $DIR/$tdir || error "rmdir failed"
 
@@ -3034,7 +3059,7 @@ test_81h() {
 
        wait $CLIENT_PID || error "rm remote dir failed"
 
-       stat $remote_dir 2&>/dev/null && error "$remote_dir still exist!"
+       stat $remote_dir &>/dev/null && error "$remote_dir still exist!"
 
        rm -rf $DIR/$tdir || error "rmdir failed"
 
@@ -3080,24 +3105,22 @@ test_85a() { #bug 16774
 run_test 85a "check the cancellation of unused locks during recovery(IBITS)"
 
 test_85b() { #bug 16774
-       lctl set_param -n ldlm.cancel_unused_locks_before_replay "1"
+       rm -rf $DIR/$tdir
+       mkdir $DIR/$tdir
 
-       create_pool $FSNAME.$TESTNAME ||
-               error "unable to create pool $TESTNAME"
-       do_facet mgs $LCTL pool_add $FSNAME.$TESTNAME $FSNAME-OST0000 ||
-               error "unable to add pool $TESTNAME"
+       lctl set_param -n ldlm.cancel_unused_locks_before_replay "1"
 
-       $SETSTRIPE -c 1 -p $FSNAME.$TESTNAME $DIR
+       $LFS setstripe -c 1 -i 0 $DIR/$tdir
 
        for i in $(seq 100); do
-               dd if=/dev/urandom of=$DIR/$tfile-$i bs=4096 \
+               dd if=/dev/urandom of=$DIR/$tdir/$tfile-$i bs=4096 \
                        count=32 >/dev/null 2>&1
        done
 
        cancel_lru_locks osc
 
        for i in $(seq 100); do
-               dd if=$DIR/$tfile-$i of=/dev/null bs=4096 \
+               dd if=$DIR/$tdir/$tfile-$i of=/dev/null bs=4096 \
                        count=32 >/dev/null 2>&1
        done
 
@@ -3114,14 +3137,11 @@ test_85b() { #bug 16774
                 -n ldlm.namespaces.*OST0000*$addr.lock_unused_count)
        echo "after recovery: unused locks count = $count2"
 
-       do_facet mgs $LCTL pool_remove $FSNAME.$TESTNAME $FSNAME-OST0000 ||
-               error "unable to remove pool $TESTNAME"
-       do_facet mgs $LCTL pool_destroy $FSNAME.$TESTNAME ||
-               error "unable to destroy the pool $TESTNAME"
-
        if [ $count2 -ge $count ]; then
                error "unused locks are not canceled"
        fi
+
+       rm -rf $DIR/$tdir
 }
 run_test 85b "check the cancellation of unused locks during recovery(EXTENT)"
 
@@ -3139,7 +3159,7 @@ test_87a() {
        do_facet ost1 "lctl set_param -n obdfilter.${ost1_svc}.sync_journal 0"
 
        replay_barrier ost1
-       $SETSTRIPE -i 0 -c 1 $DIR/$tfile
+       $LFS setstripe -i 0 -c 1 $DIR/$tfile
        dd if=/dev/urandom of=$DIR/$tfile bs=1024k count=8 ||
                error "dd to $DIR/$tfile failed"
        cksum=$(md5sum $DIR/$tfile | awk '{print $1}')
@@ -3157,7 +3177,7 @@ test_87b() {
        do_facet ost1 "lctl set_param -n obdfilter.${ost1_svc}.sync_journal 0"
 
        replay_barrier ost1
-       $SETSTRIPE -i 0 -c 1 $DIR/$tfile
+       $LFS setstripe -i 0 -c 1 $DIR/$tfile
        dd if=/dev/urandom of=$DIR/$tfile bs=1024k count=8 ||
                error "dd to $DIR/$tfile failed"
        sleep 1 # Give it a chance to flush dirty data
@@ -3177,16 +3197,16 @@ test_88() { #bug 17485
        mkdir $DIR/$tdir || error "mkdir $DIR/$tdir failed"
        mkdir -p $TMP/$tdir || error "mkdir $TMP/$tdir failed"
 
-       $SETSTRIPE -i 0 -c 1 $DIR/$tdir || error "$SETSTRIPE"
+       $LFS setstripe -i 0 -c 1 $DIR/$tdir || error "$LFS setstripe failed"
 
        replay_barrier ost1
        replay_barrier $SINGLEMDS
 
-    # exhaust precreations on ost1
-    local OST=$(ostname_from_index 0)
-    local mdtosc=$(get_mdtosc_proc_path $SINGLEMDS $OST)
-    local last_id=$(do_facet $SINGLEMDS lctl get_param -n osc.$mdtosc.prealloc_last_id)
-    local next_id=$(do_facet $SINGLEMDS lctl get_param -n osc.$mdtosc.prealloc_next_id)
+       # exhaust precreations on ost1
+       local OST=$(ostname_from_index 0)
+       local mdtosc=$(get_mdtosc_proc_path $SINGLEMDS $OST)
+       local last_id=$(do_facet $SINGLEMDS lctl get_param -n osp.$mdtosc.prealloc_last_id)
+       local next_id=$(do_facet $SINGLEMDS lctl get_param -n osp.$mdtosc.prealloc_next_id)
        echo "before test: last_id = $last_id, next_id = $next_id"
 
        echo "Creating to objid $last_id on ost $OST..."
@@ -3198,8 +3218,8 @@ test_88() { #bug 17485
        createmany -o $DIR/$tdir/f-%d $last_id 8 ||
                error "createmany create files with uncommitted objids failed"
 
-    last_id2=$(do_facet $SINGLEMDS lctl get_param -n osc.$mdtosc.prealloc_last_id)
-    next_id2=$(do_facet $SINGLEMDS lctl get_param -n osc.$mdtosc.prealloc_next_id)
+    last_id2=$(do_facet $SINGLEMDS lctl get_param -n osp.$mdtosc.prealloc_last_id)
+    next_id2=$(do_facet $SINGLEMDS lctl get_param -n osp.$mdtosc.prealloc_next_id)
     echo "before recovery: last_id = $last_id2, next_id = $next_id2" 
 
     # if test uses shutdown_facet && reboot_facet instead of facet_failover ()
@@ -3222,8 +3242,8 @@ test_88() { #bug 17485
 
     clients_up
 
-    last_id2=$(do_facet $SINGLEMDS lctl get_param -n osc.$mdtosc.prealloc_last_id)
-    next_id2=$(do_facet $SINGLEMDS lctl get_param -n osc.$mdtosc.prealloc_next_id)
+    last_id2=$(do_facet $SINGLEMDS lctl get_param -n osp.$mdtosc.prealloc_last_id)
+    next_id2=$(do_facet $SINGLEMDS lctl get_param -n osp.$mdtosc.prealloc_next_id)
        echo "after recovery: last_id = $last_id2, next_id = $next_id2"
 
        # create new files, which should use new objids, and ensure the orphan
@@ -3255,15 +3275,24 @@ test_88() { #bug 17485
 }
 run_test 88 "MDS should not assign same objid to different files "
 
+function calc_osc_kbytes_used() {
+       local kbtotal=$(calc_osc_kbytes kbytestotal)
+       local kbfree=$(calc_osc_kbytes kbytesfree)
+       echo $((kbtotal-kbfree))
+}
+
 test_89() {
        cancel_lru_locks osc
        mkdir $DIR/$tdir || error "mkdir $DIR/$tdir failed"
        rm -f $DIR/$tdir/$tfile
-       wait_mds_ost_sync
-       wait_delete_completed
-       BLOCKS1=$(df -P $MOUNT | tail -n 1 | awk '{ print $3 }')
-       $SETSTRIPE -i 0 -c 1 $DIR/$tdir/$tfile
-       dd if=/dev/zero bs=1M count=10 of=$DIR/$tdir/$tfile
+       wait_mds_ost_sync || error "initial MDS-OST sync timed out"
+       wait_delete_completed || error "initial wait delete timed out"
+       local blocks1=$(calc_osc_kbytes_used)
+       local write_size=$(fs_log_size)
+
+       $LFS setstripe -i 0 -c 1 $DIR/$tdir/$tfile
+       [ $write_size -lt 1024 ] && write_size=1024
+       dd if=/dev/zero bs=${write_size}k count=10 of=$DIR/$tdir/$tfile
        sync
        stop ost1
        facet_failover $SINGLEMDS
@@ -3272,23 +3301,30 @@ test_89() {
        mount_facet ost1
        zconf_mount $(hostname) $MOUNT || error "mount fails"
        client_up || error "client_up failed"
-       wait_mds_ost_sync
-       wait_delete_completed
-       BLOCKS2=$(df -P $MOUNT | tail -n 1 | awk '{ print $3 }')
-       [ $((BLOCKS2 - BLOCKS1)) -le 4  ] ||
-               error $((BLOCKS2 - BLOCKS1)) blocks leaked
-}
 
+       # wait for the remounted client to connect to ost1
+       local target=$(get_osc_import_name client ost1)
+       wait_import_state "FULL" "osc.${target}.ost_server_uuid" \
+               $(max_recovery_time)
+
+       wait_mds_ost_sync || error "MDS-OST sync timed out"
+       wait_delete_completed || error "wait delete timed out"
+       local blocks2=$(calc_osc_kbytes_used)
+
+       [ $((blocks2 - blocks1)) -le $(fs_log_size)  ] ||
+               error $((blocks2 - blocks1)) blocks leaked
+}
 run_test 89 "no disk space leak on late ost connection"
 
 cleanup_90 () {
-    local facet=$1
-    trap 0
-    reboot_facet $facet
-    change_active $facet
-    wait_for_facet $facet
-    mount_facet $facet || error "Restart of $facet failed"
-    clients_up
+       local facet=$1
+
+       trap 0
+       reboot_facet $facet
+       change_active $facet
+       wait_for_facet $facet
+       mount_facet $facet || error "Restart of $facet failed"
+       clients_up
 }
 
 test_90() { # bug 19494
@@ -3309,25 +3345,30 @@ test_90() { # bug 19494
 
        echo "Create the files"
 
-    # file "f${index}" striped over 1 OST
-    # file "all" striped over all OSTs
+       # file "f${index}" striped over 1 OST
+       # file "all" striped over all OSTs
 
-    $SETSTRIPE -c $OSTCOUNT $dir/all ||
-        error "setstripe failed to create $dir/all"
+       $LFS setstripe -c $OSTCOUNT $dir/all ||
+               error "setstripe failed to create $dir/all"
 
-    for (( i=0; i<$OSTCOUNT; i++ )); do
-        local f=$dir/f$i
-        $SETSTRIPE -i $i -c 1 $f || error "$SETSTRIPE failed to create $f"
+       for ((i = 0; i < $OSTCOUNT; i++)); do
+               local f=$dir/f$i
 
-        # confirm setstripe actually created the stripe on the requested OST
-        local uuid=$(ostuuid_from_index $i)
-        for file in f$i all; do
-            if [[ $dir/$file != $($LFS find --obd $uuid --name $file $dir) ]]; then
-               $GETSTRIPE $dir/$file
-               error wrong stripe: $file, uuid: $uuid
-            fi
-        done
-    done
+               $LFS setstripe -i $i -c 1 $f ||
+                       error "$LFS setstripe failed to create $f"
+
+               # confirm setstripe actually created stripe on requested OST
+               local uuid=$(ostuuid_from_index $i)
+
+               for file in f$i all; do
+                       local found=$($LFS find --obd $uuid --name $file $dir)
+
+                       if [[ $dir/$file != $found ]]; then
+                               $LFS getstripe $dir/$file
+                               error "wrong stripe: $file, uuid: $uuid"
+                       fi
+               done
+       done
 
        # Before failing an OST, get its obd name and index
        local varsvc=${ostfail}_svc
@@ -3363,9 +3404,9 @@ test_90() { # bug 19494
     [[ $(echo $list | wc -w) -eq 2 ]] ||
         error_noexit "lfs find reports the wrong list of affected files ${#list[@]}"
 
-    echo "Check getstripe: $GETSTRIPE -r --obd $obd"
-    list=$($GETSTRIPE -r --obd $obd $dir)
-    echo "$list"
+       echo "Check getstripe: $LFS getstripe -r --obd $obd"
+       list=$($LFS getstripe -r --obd $obd $dir)
+       echo "$list"
     for file in all f$index; do
         echo "$list" | grep $dir/$file ||
             error_noexit "lfs getsripe does not report the affected $obd for $file"
@@ -3376,16 +3417,15 @@ test_90() { # bug 19494
 run_test 90 "lfs find identifies the missing striped file segments"
 
 test_93a() {
-       local server_version=$(lustre_version_code $SINGLEMDS)
-               [[ $server_version -ge $(version_code 2.6.90) ]] ||
-               [[ $server_version -ge $(version_code 2.5.4) &&
-                  $server_version -lt $(version_code 2.5.50) ]] ||
-               { skip "Need MDS version 2.5.4+ or 2.6.90+"; return; }
+       [[ "$MDS1_VERSION" -ge $(version_code 2.6.90) ]] ||
+               [[ "$MDS1_VERSION" -ge $(version_code 2.5.4) &&
+                  "$MDS1_VERSION" -lt $(version_code 2.5.50) ]] ||
+               skip "Need MDS version 2.5.4+ or 2.6.90+"
 
        cancel_lru_locks osc
 
-       $SETSTRIPE -i 0 -c 1 $DIR/$tfile ||
-               error "$SETSTRIPE  $DIR/$tfile failed"
+       $LFS setstripe -i 0 -c 1 $DIR/$tfile ||
+               error "$LFS setstripe  $DIR/$tfile failed"
        dd if=/dev/zero of=$DIR/$tfile bs=1024 count=1 ||
                error "dd to $DIR/$tfile failed"
        #define OBD_FAIL_TGT_REPLAY_RECONNECT     0x715
@@ -3400,9 +3440,8 @@ test_93a() {
 run_test 93a "replay + reconnect"
 
 test_93b() {
-       local server_version=$(lustre_version_code $SINGLEMDS)
-               [[ $server_version -ge $(version_code 2.7.90) ]] ||
-               { skip "Need MDS version 2.7.90+"; return; }
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.90) ]] ||
+               skip "Need MDS version 2.7.90+"
 
        cancel_lru_locks mdc
 
@@ -3732,7 +3771,10 @@ test_102d() {
 run_test 102d "check replay & reconstruction with multiple mod RPCs in flight"
 
 test_103() {
-       remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       remote_mds_nodsh && skip "remote MDS with nodsh"
+       [[ "$MDS1_VERSION" -gt $(version_code 2.8.54) ]] ||
+               skip "Need MDS version 2.8.54+"
+
 #define OBD_FAIL_MDS_TRACK_OVERFLOW 0x162
        do_facet mds1 $LCTL set_param fail_loc=0x80000162
 
@@ -3759,6 +3801,9 @@ check_striped_dir_110()
 
 test_110a() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -3778,6 +3823,9 @@ run_test 110a "DNE: create striped dir, fail MDT1"
 
 test_110b() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -3801,6 +3849,9 @@ run_test 110b "DNE: create striped dir, fail MDT1 and client"
 
 test_110c() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -3821,6 +3872,9 @@ run_test 110c "DNE: create striped dir, fail MDT2"
 
 test_110d() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -3844,6 +3898,9 @@ run_test 110d "DNE: create striped dir, fail MDT2 and client"
 
 test_110e() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -3868,6 +3925,9 @@ run_test 110e "DNE: create striped dir, uncommit on MDT2, fail client/MDT1/MDT2"
 
 test_110f() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -3877,7 +3937,7 @@ test_110f() {
        replay_barrier mds1
        replay_barrier mds2
        $LFS mkdir -i1 -c$MDSCOUNT $DIR/$tdir/striped_dir
-       fail mds1,mds2
+       fail mds2,mds1
 
        check_striped_dir_110 || error "check striped_dir failed"
 
@@ -3889,6 +3949,9 @@ run_test 110f "DNE: create striped dir, fail MDT1/MDT2"
 
 test_110g() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -3913,6 +3976,9 @@ run_test 110g "DNE: create striped dir, uncommit on MDT1, fail client/MDT1/MDT2"
 
 test_111a() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -3932,6 +3998,9 @@ run_test 111a "DNE: unlink striped dir, fail MDT1"
 
 test_111b() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -3954,6 +4023,9 @@ run_test 111b "DNE: unlink striped dir, fail MDT2"
 
 test_111c() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -3976,6 +4048,9 @@ run_test 111c "DNE: unlink striped dir, uncommit on MDT1, fail client/MDT1/MDT2"
 
 test_111d() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -3999,6 +4074,9 @@ run_test 111d "DNE: unlink striped dir, uncommit on MDT2, fail client/MDT1/MDT2"
 
 test_111e() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4018,6 +4096,9 @@ run_test 111e "DNE: unlink striped dir, uncommit on MDT2, fail MDT1/MDT2"
 
 test_111f() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4037,6 +4118,9 @@ run_test 111f "DNE: unlink striped dir, uncommit on MDT1, fail MDT1/MDT2"
 
 test_111g() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4079,6 +4163,9 @@ test_112_check() {
 
 test_112a() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4098,6 +4185,9 @@ run_test 112a "DNE: cross MDT rename, fail MDT1"
 
 test_112b() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4118,6 +4208,9 @@ run_test 112b "DNE: cross MDT rename, fail MDT2"
 
 test_112c() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4138,6 +4231,9 @@ run_test 112c "DNE: cross MDT rename, fail MDT3"
 
 test_112d() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4158,6 +4254,9 @@ run_test 112d "DNE: cross MDT rename, fail MDT4"
 
 test_112e() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4179,6 +4278,9 @@ run_test 112e "DNE: cross MDT rename, fail MDT1 and MDT2"
 
 test_112f() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4200,6 +4302,9 @@ run_test 112f "DNE: cross MDT rename, fail MDT1 and MDT3"
 
 test_112g() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4221,6 +4326,9 @@ run_test 112g "DNE: cross MDT rename, fail MDT1 and MDT4"
 
 test_112h() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4242,6 +4350,9 @@ run_test 112h "DNE: cross MDT rename, fail MDT2 and MDT3"
 
 test_112i() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4263,6 +4374,9 @@ run_test 112i "DNE: cross MDT rename, fail MDT2 and MDT4"
 
 test_112j() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4284,6 +4398,9 @@ run_test 112j "DNE: cross MDT rename, fail MDT3 and MDT4"
 
 test_112k() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4306,6 +4423,9 @@ run_test 112k "DNE: cross MDT rename, fail MDT1,MDT2,MDT3"
 
 test_112l() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4328,6 +4448,9 @@ run_test 112l "DNE: cross MDT rename, fail MDT1,MDT2,MDT4"
 
 test_112m() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4350,6 +4473,9 @@ run_test 112m "DNE: cross MDT rename, fail MDT1,MDT3,MDT4"
 
 test_112n() {
        [ $MDSCOUNT -lt 4 ] && skip "needs >= 4 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4372,6 +4498,9 @@ run_test 112n "DNE: cross MDT rename, fail MDT2,MDT3,MDT4"
 
 test_115() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
+
        ([ $FAILURE_MODE == "HARD" ] &&
                [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
                skip "MDTs needs to be on diff hosts for HARD fail mode" &&
@@ -4404,7 +4533,7 @@ run_test 115 "failover for create/unlink striped directory"
 
 test_116a() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
-       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.55) ] &&
+       [ "$MDS1_VERSION" -lt $(version_code 2.7.55) ] &&
                skip "Do not support large update log before 2.7.55" &&
                return 0
        ([ $FAILURE_MODE == "HARD" ] &&
@@ -4418,7 +4547,7 @@ test_116a() {
 
        # OBD_FAIL_SPLIT_UPDATE_REC       0x1702
        do_facet mds1 "lctl set_param fail_loc=0x80001702"
-       $LFS setdirstripe -c$MDSCOUNT $DIR/$tdir/striped_dir
+       $LFS setdirstripe -i0 -c$MDSCOUNT $DIR/$tdir/striped_dir
 
        fail mds1
        $CHECKSTAT -t dir $DIR/$tdir/striped_dir ||
@@ -4428,7 +4557,7 @@ run_test 116a "large update log master MDT recovery"
 
 test_116b() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
-       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.55) ] &&
+       [ "$MDS1_VERSION" -lt $(version_code 2.7.55) ] &&
                skip "Do not support large update log before 2.7.55" &&
                return 0
 
@@ -4443,7 +4572,7 @@ test_116b() {
 
        # OBD_FAIL_SPLIT_UPDATE_REC       0x1702
        do_facet mds2 "lctl set_param fail_loc=0x80001702"
-       $LFS setdirstripe -c$MDSCOUNT $DIR/$tdir/striped_dir
+       $LFS setdirstripe -i0 -c$MDSCOUNT $DIR/$tdir/striped_dir
 
        fail mds2
        $CHECKSTAT -t dir $DIR/$tdir/striped_dir ||
@@ -4489,7 +4618,7 @@ run_test 117 "DNE: cross MDT unlink, fail MDT1 and MDT2"
 
 test_118() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
-       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.64) ] &&
+       [ "$MDS1_VERSION" -lt $(version_code 2.7.64) ] &&
                skip "Do not support large update log before 2.7.64" &&
                return 0
 
@@ -4518,7 +4647,7 @@ run_test 118 "invalidate osp update will not cause update log corruption"
 
 test_119() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
-       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.64) ] &&
+       [ "$MDS1_VERSION" -lt $(version_code 2.7.64) ] &&
                skip "Do not support large update log before 2.7.64" &&
                return 0
        local stripe_count
@@ -4535,7 +4664,7 @@ test_119() {
        replay_barrier mds1
        mkdir $DIR/$tdir/dir_1
        for ((i = 0; i < 20; i++)); do
-               $LFS setdirstripe -c2 $DIR/$tdir/stripe_dir-$i
+               $LFS setdirstripe -i0 -c2 $DIR/$tdir/stripe_dir-$i
        done
 
        stop mds1
@@ -4570,7 +4699,7 @@ run_test 119 "timeout of normal replay does not cause DNE replay fails  "
 
 test_120() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
-       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.64) ] &&
+       [ "$MDS1_VERSION" -lt $(version_code 2.7.64) ] &&
                skip "Do not support large update log before 2.7.64" &&
                return 0
 
@@ -4581,7 +4710,7 @@ test_120() {
                        error "create dir-$i fails"
                        break
                }
-               $LFS setdirstripe -c2 $DIR/$tdir/stripe_dir-$i || {
+               $LFS setdirstripe -i0 -c2 $DIR/$tdir/stripe_dir-$i || {
                        error "create stripe_dir-$i fails"
                        break
                }
@@ -4602,6 +4731,185 @@ test_120() {
 }
 run_test 120 "DNE fail abort should stop both normal and DNE replay"
 
+test_121() {
+       [ "$MDS1_VERSION" -lt $(version_code 2.10.90) ] &&
+               skip "Don't support it before 2.11" &&
+               return 0
+
+       local at_max_saved=$(at_max_get mds)
+
+       touch $DIR/$tfile || error "touch $DIR/$tfile failed"
+       cancel_lru_locks mdc
+
+       multiop_bg_pause $DIR/$tfile s_s || error "multiop $DIR/$tfile failed"
+       mpid=$!
+
+       lctl set_param -n ldlm.cancel_unused_locks_before_replay "0"
+
+       stop mds1
+       change_active mds1
+       wait_for_facet mds1
+
+       #define OBD_FAIL_TGT_RECOVERY_REQ_RACE  0x721
+       do_facet $SINGLEMDS "lctl set_param fail_loc=0x721 fail_val=0"
+       at_max_set 0 mds
+
+       mount_facet mds1
+       wait_clients_import_state "$clients" mds1 FULL
+       clients_up || clients_up || error "failover df: $?"
+
+       kill -USR1 $mpid
+       wait $mpid || error "multiop_bg_pause pid failed"
+
+       do_facet $SINGLEMDS "lctl set_param fail_loc=0x0"
+       lctl set_param -n ldlm.cancel_unused_locks_before_replay "1"
+       at_max_set $at_max_saved mds
+       rm -f $DIR/$tfile
+}
+run_test 121 "lock replay timed out and race"
+
+test_130a() {
+       [ "$MDS1_VERSION" -lt $(version_code 2.10.90) ] &&
+               skip "Do not support Data-on-MDT before 2.11"
+
+       replay_barrier $SINGLEMDS
+       $LFS setstripe -E 1M -L mdt -E EOF -c 2 $DIR/$tfile
+       fail $SINGLEMDS
+
+       [ $($LFS getstripe -L $DIR/$tfile) == "mdt" ] ||
+               error "Fail to replay DoM file creation"
+}
+run_test 130a "DoM file create (setstripe) replay"
+
+test_130b() {
+       [ "$MDS1_VERSION" -lt $(version_code 2.10.90) ] &&
+               skip "Do not support Data-on-MDT before 2.11"
+
+       mkdir $DIR/$tdir
+       $LFS setstripe -E 1M -L mdt -E EOF -c 2 $DIR/$tdir
+       replay_barrier $SINGLEMDS
+       touch $DIR/$tdir/$tfile
+       fail $SINGLEMDS
+
+       [ $($LFS getstripe -L $DIR/$tdir/$tfile) == "mdt" ] ||
+               error "Fail to replay DoM file creation"
+}
+run_test 130b "DoM file create (inherited) replay"
+
+test_131a() {
+       [ "$MDS1_VERSION" -lt $(version_code 2.10.90) ] &&
+               skip "Do not support Data-on-MDT before 2.11"
+
+       $LFS setstripe -E 1M -L mdt -E EOF -c 2 $DIR/$tfile
+       replay_barrier $SINGLEMDS
+       echo "dom_data" | dd of=$DIR/$tfile bs=8 count=1
+       # lock is not canceled and will be replayed
+       fail $SINGLEMDS
+
+       [ $(cat $DIR/$tfile) == "dom_data" ] ||
+               error "Wrong file content after failover"
+}
+run_test 131a "DoM file write lock replay"
+
+test_131b() {
+       [ "$MDS1_VERSION" -lt $(version_code 2.10.90) ] &&
+               skip "Do not support Data-on-MDT before 2.11"
+
+       $LFS setstripe -E 1M -L mdt -E EOF -c 2 $DIR/$tfile
+       replay_barrier $SINGLEMDS
+       echo "dom_data" | dd of=$DIR/$tfile bs=8 count=1
+       cancel_lru_locks mdc
+
+       fail $SINGLEMDS
+
+       [ $(cat $DIR/$tfile) == "dom_data" ] ||
+               error "Wrong file content after failover"
+}
+run_test 131b "DoM file write replay"
+
+test_132a() {
+       [ "$MDS1_VERSION" -lt $(version_code 2.12.0) ] &&
+               skip "Need MDS version 2.12.0 or later"
+
+       $LFS setstripe -E 1M -c 1 -E EOF -c 2 $DIR/$tfile
+       replay_barrier $SINGLEMDS
+       # write over the first component size cause next component instantiation
+       dd if=/dev/urandom of=$DIR/$tfile bs=1M count=1 seek=1 ||
+               error "dd to $DIR/$tfile failed"
+       lfs getstripe $DIR/$tfile
+
+       cksum=$(md5sum $DIR/$tfile | awk '{print $1}')
+       $LFS getstripe -I2 $DIR/$tfile | grep -q lmm_objects ||
+               error "Component #1 was not instantiated"
+
+       fail $SINGLEMDS
+
+       lfs getstripe $DIR/$tfile
+       $LFS getstripe -I2 $DIR/$tfile | grep -q lmm_objects ||
+               error "Component #1 instantiation was not replayed"
+       cksum2=$(md5sum $DIR/$tfile | awk '{print $1}')
+       if [ $cksum != $cksum2 ] ; then
+               error_noexit "New cksum $cksum2 does not match original $cksum"
+       fi
+}
+run_test 132a "PFL new component instantiate replay"
+
+test_133() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
+       ([ $FAILURE_MODE == "HARD" ] &&
+               [ "$(facet_host mds1)" == "$(facet_host mds2)" ]) &&
+               skip "MDTs needs to be on diff hosts for HARD fail mode" &&
+               return 0
+
+       local remote_dir=$DIR/$tdir/remote_dir
+
+       mkdir -p $DIR/$tdir || error "mkdir $DIR/$tdir failed"
+       $LFS mkdir -i 1 $remote_dir
+
+       umount $MOUNT
+       do_facet mds2 $LCTL set_param seq.srv*MDT0001.space=clear
+
+       zconf_mount $(hostname) $MOUNT
+       client_up || return 1
+
+       #define OBD_FAIL_MDS_ALL_REQUEST_NET     0x123
+       # SEQ_QUERY                       = 700
+       do_facet mds1 $LCTL set_param fail_val=700 fail_loc=0x80000123
+       cp /etc/hosts $remote_dir/file &
+       local pid=$!
+       sleep 1
+
+       fail_nodf mds1
+
+       wait $pid || error "cp failed"
+       rm -rf $DIR/$tdir || error "rmdir failed"
+
+       return 0
+}
+run_test 133 "check resend of ongoing requests for lwp during failover"
+
+test_134() {
+       [ $OSTCOUNT -lt 2 ] && skip "needs >= 2 OSTs" && return 0
+
+       pool_add pool_134
+       pool_add_targets pool_134 1 1
+
+       mkdir -p $DIR/$tdir/{A,B}
+       $LFS setstripe -p pool_134 $DIR/$tdir/A
+       $LFS setstripe -E EOF -p pool_134 $DIR/$tdir/B
+
+       replay_barrier mds1
+
+       touch $DIR/$tdir/A/$tfile || error "touch non-pfl file failed"
+       touch $DIR/$tdir/B/$tfile || error "touch pfl failed"
+
+       fail mds1
+
+       [ -f $DIR/$tdir/A/$tfile ] || error "non-pfl file does not exist"
+       [ -f $DIR/$tdir/B/$tfile ] || error "pfl file does not exist"
+}
+run_test 134 "replay creation of a file created in a pool"
+
 complete $SECONDS
 check_and_cleanup_lustre
 exit_status